--------------------INFO--------------------
-- Doppelganger/FuBar_CritterInfu. Revisited on February 13th, 2007 and revised on March 20th, 2007. 
-- Upgraded to Ace2 & Fubar 2.0.
-- This addon has been modified by the Doppleganger! (Kayde of Alleria). 
-- Credit is due to Jayhawk [Fubar_PetInfoFu (orignal code)], Ricowan [Fubar_PetFu (features)], & Kemayo [Fubar_PetInFu (features)].
-- Additional credits are due to Mark Murray [PetXPBar (long since abandoned)] and Corgi [FuBar - PetInfo], 
--   from whos works I based much of my orignal code on (read - stole from, lol).
-- My personal thanks to all of them for laying the groundwork for my reverse engineering efforts!! :) Much love yall!!
-- I added several features to this addon, combining my outdated CritterInFu addon and this one, including:
--   *extention and reorganization of menu options to replace some action buttons
--   *additional Warlock support to make it a proper compliment to other addons like ShardAce, Necronomicon, or Necrosis.
--   *reorganization of tooltip layout, including toggle-able sections for all categories.
--   *additional details on pets - even stuff you wish you never knew!
-- I removed the Pet History features of PetInfoFu as I felt it was a bit redundant. 
-- I'm sorry to those that liked this function. :(


--------------------GLOBALS/LOCALS/DEFAULTS--------------------
CritterInFu = AceLibrary("AceAddon-2.0"):new(	"FuBarPlugin-2.0", "AceConsole-2.0", "AceDB-2.0", "AceEvent-2.0")

local L			= AceLibrary("AceLocale-2.2"):new("CritterInFu")
local BS		= AceLibrary("Babble-Spell-2.2")
local BST		= AceLibrary("Babble-SpellTree-2.2")
local crayon	= AceLibrary("Crayon-2.0")
local dewdrop	= AceLibrary("Dewdrop-2.0")
local tablet	= AceLibrary("Tablet-2.0")

-- hunter specific variables
local prevHappiness = 0

-- warlock specific variables
local demonicKnowledgeRank = 0
local demonicKnowledgeTalentTab = 0
local demonicKnowledgeTalentIndex = 0

-- properties
CritterInFu.clickableTooltip	= true
CritterInFu.canHideText		= true
CritterInFu.defaultPosition	= "CENTER"
CritterInFu.hasIcon			= true
CritterInFu.hasNoColor		= false

-- register database stuff
CritterInFu:RegisterDB("CritterInFuDB")
CritterInFu:RegisterDefaults('account', {stables = {},})
CritterInFu:RegisterDefaults('char', {
	showPetName 		= true,
	showPetXP 			= true,
	showPetLevel 		= true,
	showExperience 		= true,
	showBasic 			= true,
	showAttributes 		= true,
	showCombat 			= true,
	showSkills 			= true,
	showHerdInfo 		= true,
	showStableMapNotes 	= true,
	hidden 				= {},
	herdInfo 			= {},
	}
)
CritterInFu:RegisterChatCommand(L["CMD_OPTIONS"], options)



--------------------INITIALIZE/ENABLE/DISABLE--------------------
function CritterInFu:OnInitialize()
  --nothing here
end

function CritterInFu:OnEnable()
	self:RegisterEvent("PLAYER_ENTERING_WORLD","Update")
	self:RegisterEvent("PLAYER_LEVEL_UP","Update")
	self:RegisterEvent("PLAYER_PET_CHANGED","Update")
	self:RegisterEvent("UNIT_PET","Update")
	if self:IsHunter() then
		self:RegisterEvent("PET_STABLE_CLOSED")
		self:RegisterEvent("UNIT_HAPPINESS")
		self:RegisterEvent("UNIT_PET_EXPERIENCE","Update")
		self:RegisterEvent("UNIT_PET_TRAINING_POINTS","Update")
	end
	if self:IsWarlock() then
		self:GetDemonicKnowledgeRank()
		self:RegisterEvent("CHARACTER_POINTS_CHANGED")
	end

	-- mapnotes
	if Cartographer_Notes then
		Cartographer_Notes:RegisterIcon("Stable", {text = L["STABLEMP"], path = "Interface\\AddOns\\FuBar_CritterInFu\\icons\\stable.tga"})
		Cartographer_Notes:RegisterNotesDatabase('CritterInFu', self.db.account.stables, self)
	end
end

function CritterInFu:OnDisable()
	if Cartographer_Notes then
		Cartographer_Notes:UnregisterIcon("Stable")  
		Cartographer_Notes:UnregisterNotesDatabase('CritterInFu')
	end
	self:UnregisterAllEvents()
end

--------------------EVENTS/FUNCTIONS--------------------
function CritterInFu:UNIT_HAPPINESS()
	local happiness = GetPetHappiness()
	if happiness ~= prevHappiness then
		prevHappiness = happiness
		self:Update()
	end
end

function CritterInFu:PET_STABLE_CLOSED()
	self:GetHerdInfo()
	if Cartographer_Notes and 
		self.db.char.showStableMapNotes then
		self:AddStableMapNote()
	end
end

function CritterInFu:CHARACTER_POINTS_CHANGED()
	self:GetDemonicKnowledgeRank()
end

function CritterInFu:IsHunter()
	local _, englishClass = UnitClass("player")
	return englishClass == "HUNTER"
end
function CritterInFu:IsWarlock()
	local _, englishClass = UnitClass("player")
	return englishClass == "WARLOCK"
end

--Toggle Action Template
function CritterInFu:ToggleCategory(id, button)
	self.db.char.hidden[id] = not self.db.char.hidden[id]
	self:UpdateTooltip()
end

--Header Name
function CritterInFu:IsShowingHPetName()
	return self.db.char.showPetName
end
function CritterInFu:ToggleIsShowingHPetName()
	self.db.char.showPetName = not self.db.char.showPetName
	if not (self.db.char.showPetName or self.db.char.showPetXP or self.db.char.showPetLevel) then self:ShowIcon() end
	self:UpdateText()
	return self.db.char.showPetName
end
--Header Level
function CritterInFu:IsShowingHPetLevel()
	return self.db.char.showPetLevel
end
function CritterInFu:ToggleIsShowingHPetLevel()
	self.db.char.showPetLevel = not self.db.char.showPetLevel
	if not (self.db.char.showPetName or self.db.char.showPetXP or self.db.char.showPetLevel) then self:ShowIcon() end
	self:UpdateText()
	return self.db.char.showPetLevel
end
--Header Experience
function CritterInFu:IsShowingHPetXP()
	return self.db.char.showPetXP
end
function CritterInFu:ToggleIsShowingHPetXP()
	self.db.char.showPetXP = not self.db.char.showPetXP
	if not (self.db.char.showPetName or self.db.char.showPetXP or self.db.char.showPetLevel) then self:ShowIcon() end
	self:UpdateText()
	return self.db.char.showPetXP
end

--Tooltip XP
function CritterInFu:IsShowingExperience()
	return self.db.char.showExperience
end
function CritterInFu:ToggleIsShowingExperience()
	self.db.char.showExperience = not self.db.char.showExperience
	self:UpdateTooltip()
	return self.db.char.showExperience
end
--Tooltip Basic Info
function CritterInFu:IsShowingBasic()
	return self.db.char.showBasic
end
function CritterInFu:ToggleIsShowingBasic()
	self.db.char.showBasic = not self.db.char.showBasic
	self:UpdateTooltip()
	return self.db.char.showBasic
end
--Tooltip Attributes
function CritterInFu:IsShowingAttributes()
	return self.db.char.showAttributes
end
function CritterInFu:ToggleIsShowingAttributes()
	self.db.char.showAttributes = not self.db.char.showAttributes
	self:UpdateTooltip()
	return self.db.char.showAttributes
end
--Tooltip Combat Stats
function CritterInFu:IsShowingCombat()
	return self.db.char.showCombat
end
function CritterInFu:ToggleIsShowingCombat()
	self.db.char.showCombat = not self.db.char.showCombat
	self:UpdateTooltip()
	return self.db.char.showCombat
end
--Tooltip Skills
function CritterInFu:IsShowingSkills()
	return self.db.char.showSkills
end
function CritterInFu:ToggleIsShowingSkills()
	self.db.char.showSkills = not self.db.char.showSkills
	self:UpdateTooltip()
	return self.db.char.showSkills
end
--Tooltip Herd Info
function CritterInFu:IsShowingHerdInfo()
	return self.db.char.showHerdInfo
end
function CritterInFu:ToggleIsShowingHerdInfo()
	self.db.char.showHerdInfo = not self.db.char.showHerdInfo
	self:UpdateTooltip()
	return self.db.char.showHerdInfo
end
--Tooltip Stable Mapnote toggle
function CritterInFu:IsShowingStableMapNotes()
	return self.db.char.showStableMapNotes
end
function CritterInFu:ToggleIsShowingStableMapNotes()
	self.db.char.showStableMapNotes = not self.db.char.showStableMapNotes
	self:UpdateTooltip()
	return self.db.char.showStableMapNotes
end

--Warlock Demon Knowledge Check
function CritterInFu:GetDemonicKnowledgeRank()
	if (demonicKnowledgeTalentTab == 0 or demonicKnowledgeTalentIndex == 0) then
		for i = 1, GetNumTalentTabs() do
			local tabName = GetTalentTabInfo(i)
			if (tabName == BST["Demonology"]) then
				demonicKnowledgeTalentTab = i
				for j = 1, GetNumTalents(i) do
					local talentName, _, _, _, currentRank = GetTalentInfo(demonicKnowledgeTalentTab, j)
					if talentName == BS["Demonic Knowledge"] then
						demonicKnowledgeTalentIndex = j
						--set currentRank
						demonicKnowledgeRank = currentRank
					end
				end
			end
		end
	else
		local _, _, _, _, currentRank = GetTalentInfo(demonicKnowledgeTalentTab, demonicKnowledgeTalentIndex)
		-- set currentRank
		demonicKnowledgeRank = currentRank
	end
	self:Update()
end

--Herd Functions
function CritterInFu:GetHerdInfo()
	self.db.char.herdInfo = nil
	self.db.char.herdInfo = {}
	for i = 1, GetNumStableSlots() do  -- i = 0 for current pet
		local _, petName, petLevel, petType, _ = GetStablePetInfo(i)
		if petName ~= nil then
			self.db.char.herdInfo[i] = {
				PetName = petName,
				PetType = petType,
				PetLevel = petLevel
			}
		end
	end
	self:Update()
end
function CritterInFu:AddHerdInfo()
	local tooltipLine = tablet:AddCategory('id', L["TT_HERD_INFO"], 'columns', 2,
											'text', UnitName("player").."'s "..L["TT_HERD_INFO"],
											'func', 'ToggleCategory', 'arg1', self, 'arg2', L["TT_HERD_INFO"],
											'child_textR', 1, 'child_textG', 0.8, 'child_textB', 0,
											'showWithoutChildren', true,
											'checked', true, 'hasCheck', true, 'checkIcon',
											self.db.char.hidden[L["TT_HERD_INFO"]] and 
											'Interface\\Buttons\\UI-PlusButton-Up' or 'Interface\\Buttons\\UI-MinusButton-Up'
	)
	if not self.db.char.hidden[L["TT_HERD_INFO"]] then
		local _, cPName, cPLevel, cPType, _ = GetStablePetInfo(0)
		local petsFound
		if cPName ~= nil then
			tooltipLine:AddLine(
				'text', "    "..crayon:Green(cPName.." ("..cPType..")"),
				'text2', crayon:Green(L["PLEVEL"]..cPLevel.." ")
			)
		end
		for k, v in pairs(self.db.char.herdInfo) do  
			tooltipLine:AddLine(
				'text', "    "..v.PetName.." ("..v.PetType..")",
				'text2', L["PLEVEL"]..v.PetLevel.." "
			)
			petsFound = true
		end
		if not petsFound then
			tooltipLine:AddLine(
				'text', "    "..L["NO_HERD_INFO"]
			)
		end
	end
end

--Stable Mapnote Recording
function CritterInFu:AddStableMapNote()
	--get coordinates and name of stable owner
	local x, y = GetPlayerMapPosition("player")
	local stableName, _ = UnitName("target")

	-- check if we have an existing note, if not add one
	if not Cartographer_Notes:GetNearbyNote(GetRealZoneText(), x, y, 0.05, 'CritterInFu') then
		Cartographer_Notes:SetNote(GetRealZoneText(), x, y, "Stable", "CritterInFu", 'title',  L["SM_TITLE"]..stableName)
	end
end

--Pet's Last XP Value
function CritterInFu:GetLastPetXP()
	local currXP, nextXP = GetPetExperience()
	local lastXP = 0
	local LastPetXP = 0
	if(LastPetXP ~= currXP or LastPetXP == nil) then
		if(LastPetXP == nil or LastPetXP == 0) then
			LastPetXP = currXP
		end
		lastXP = currXP - LastPetXP
		LastPetXP = currXP
		if lastXP < 0 then
			lastXP = 0
		end
	end
	lastXP = format("%.f", lastXP)
	return lastXP
end


--------------------DROP DOWN MENU OPTIONS--------------------	
function CritterInFu:OnMenuRequest(level, value)
	if level == 1 then
		-- Header Bar/Tooltip Options
		dewdrop:AddLine(
			'text', L["HEAD_OPTIONS"],
			'arg1', self,
			'hasArrow', true,
			'value', "H_OPTIONS"
		)
		-- Tooltip Options
		dewdrop:AddLine(
			'text', L["TOOL_OPTIONS"],
			'arg1', self,
			'hasArrow', true,
			'value', "T_OPTIONS"
		)
		if self:IsHunter() then
			-- Other Options
			dewdrop:AddLine(
				'text', L["OTHER_OPTIONS"],
				'arg1', self,
				'hasArrow', true,
				'value', "O_OPTIONS"
			)
		end
		dewdrop:AddLine()
	end
	if level == 2 then
		-- Header Bar/Tooltip Option Submenu
		if value == "H_OPTIONS" then
			-- Display Name
			dewdrop:AddLine(
				'text', L["H_NAME"],
				'tooltipTitle', L["H_NAME"],
				'tooltipText', L["H_NAME_TEXT"],
				'func', 'ToggleIsShowingHPetName',
				'arg1', self,
				'closeWhenClicked', false,
				'checked', self:IsShowingHPetName()
			)
			if self:IsHunter() then
				-- Display Level
				dewdrop:AddLine(
					'text', L["H_LVL"],
					'tooltipTitle', L["H_LVL"],
					'tooltipText', L["H_LVL_TEXT"],
					'func', 'ToggleIsShowingHPetLevel',
					'arg1', self,
					'closeWhenClicked', false,
					'checked', self:IsShowingHPetLevel()
				)
				-- Display XP
				dewdrop:AddLine(
					'text', L["H_XP"],
					'tooltipTitle', L["H_XP"],
					'tooltipText', L["H_XP_TEXT"],
					'func', 'ToggleIsShowingHPetXP',
					'arg1', self,
					'closeWhenClicked', false,
					'checked', self:IsShowingHPetXP()
				)
			end
		end
		-- Toggle Option Submenu
		if value == "T_OPTIONS" then
			if self:IsHunter() then
				-- Toggle XP Section
				dewdrop:AddLine(
					'text', L["TT_XP"],
					'tooltipTitle', L["TT_XP"],
					'tooltipText', L["TT_XP_TEXT"],
					'func', 'ToggleIsShowingExperience',
					'arg1', self,
					'closeWhenClicked', false,
					'checked', self:IsShowingExperience()
				)
				-- Toggle Standard Information
				dewdrop:AddLine(
					'text', L["TT_BASIC"],
					'tooltipTitle', L["TT_BASIC"],
					'tooltipText', L["TT_BASIC_TEXT"],
					'func', 'ToggleIsShowingBasic',
					'arg1', self,
					'closeWhenClicked', false,
					'checked', self:IsShowingBasic()
				)
			end
			-- Toggle Attributes
			dewdrop:AddLine(
				'text', L["TT_ATT"],
				'tooltipTitle', L["TT_ATT"],
				'tooltipText', L["TT_ATT_TEXT"],
				'func', 'ToggleIsShowingAttributes',
				'arg1', self,
				'closeWhenClicked', false,
				'checked', self:IsShowingAttributes()
			)
			-- Toggle Combat Information
			dewdrop:AddLine(
				'text', L["TT_COMBAT"],
				'tooltipTitle', L["TT_COMBAT"],
				'tooltipText', L["TT_COMBAT_TEXT"],
				'func', 'ToggleIsShowingCombat',
				'arg1', self,
				'closeWhenClicked', false,
				'checked', self:IsShowingCombat()
			)
			-- Toggle Skills
			dewdrop:AddLine(
				'text', L["TT_SKILLS"],
				'tooltipTitle', L["TT_SKILLS"],
				'tooltipText', L["TT_SKILLS_TEXT"],
				'func', 'ToggleIsShowingSkills',
				'arg1', self,
				'closeWhenClicked', false,
				'checked', self:IsShowingSkills()
			)
			if self:IsHunter() then
				-- Toggle Stable Parser
				dewdrop:AddLine(
					'text', L["TT_HERD_INFO"],
					'tooltipTitle', L["TT_HERD_INFO"],
					'tooltipText', L["TT_HERD_INFO_TEXT"],
					'func', 'ToggleIsShowingHerdInfo',
					'arg1', self,
					'closeWhenClicked', false,
					'checked', self:IsShowingHerdInfo()
				)
			end
		end
		-- Other Option Submenu
		if value == "O_OPTIONS" then
			if self:IsHunter() then
				-- Toggle Cartographer Stable Mapnotes
				dewdrop:AddLine(
					'text', L["TT_STABLE_MAPNOTES"],
					'tooltipTitle', L["TT_STABLE_MAPNOTES"],
					'tooltipText', L["TT_STABLE_MAPNOTES_TEXT"],
					'func', 'ToggleIsShowingStableMapNotes',
					'arg1', self,
					'closeWhenClicked', false,
					-- 'disabled', function() return not Cartographer_Notes end,
					'checked', self:IsShowingStableMapNotes()
				)
			end
		end
	end
end



--------------------TOOLTIP UPDATE--------------------	
function CritterInFu:OnTooltipUpdate()
	if HasPetUI() then
		--TOOLTIP SETUP
		local toolTip = tablet:AddCategory(
			'columns', 2,
			'child_textR', 1,
			'child_textG', 0.8,
			'child_textB', 0
		)
		local C1 = "|cffffffff"
		local C2 = "|cffa6a6ff"
		local C3 = "|cff20ff20"
		local petLVL = UnitLevel("pet")

		--SPACER
		toolTip:AddLine()

 		--PET INFO (NAME, LEVEL, TYPE)
		toolTip:AddLine(
			'text', "    "..UnitName("pet"),
			'text2', L["PLEVEL"]..petLVL.." "..UnitCreatureFamily("pet").." "
		)
		if self:IsHunter() then
			--HUNTER PET XP
			if self.db.char.showExperience then
				local tooltipLine = tablet:AddCategory('id', L["TT_XP"], 'columns', 2,
													   'text', L["TT_XP"],
													   'func', 'ToggleCategory', 'arg1', self, 'arg2', L["TT_XP"],
													   'child_textR', 1, 'child_textG', 0.8, 'child_textB', 0,
													   'showWithoutChildren', true,
													   'checked', true, 'hasCheck', true, 'checkIcon',
													   self.db.char.hidden[L["TT_XP"]] and 
													   'Interface\\Buttons\\UI-PlusButton-Up' or 'Interface\\Buttons\\UI-MinusButton-Up'
				)
				if not self.db.char.hidden[L["TT_XP"]] then
					local currXP, nextXP = GetPetExperience()
					local currentXP = currXP.." / "..nextXP..C2..format(" (%.1f", (currXP / nextXP * 100)).."%)"
					--Current/Needed XP
					tooltipLine:AddLine(
						'text', "    "..L["CURR_XP"], 
						'text2', C1..currentXP.." "
					)
					if petLVL ~= UnitLevel("player") then
						local neededXP = (nextXP - currXP)..C2..format(" (%.1f", (100 - currXP / nextXP * 100)).."%)"
						local zLastXP = self:GetLastPetXP()
						--XP to Go
						tooltipLine:AddLine(
							'text', "    "..L["NEED_XP"], 
							'text2', C1..neededXP.." "
						)
						--XP from last kill
						tooltipLine:AddLine(
							'text', "    "..L["LAST_XP"], 
							'text2', C1..zLastXP.." "
						)
					end
				end
			end
			--HUNTER PET BASIC INFO
			if self.db.char.showBasic then
				local tooltipLine = tablet:AddCategory('id', L["TT_BASIC"], 'columns', 2,
													   'text', L["TT_BASIC"],
													   'func', 'ToggleCategory', 'arg1', self, 'arg2', L["TT_BASIC"],
													   'child_textR', 1, 'child_textG', 0.8, 'child_textB', 0,
													   'showWithoutChildren', true,
													   'checked', true, 'hasCheck', true, 'checkIcon',
													   self.db.char.hidden[L["TT_BASIC"]] and 
													   'Interface\\Buttons\\UI-PlusButton-Up' or 'Interface\\Buttons\\UI-MinusButton-Up'
				)
				if not self.db.char.hidden[L["TT_BASIC"]] then
					tooltipLine:AddLine()
					local happiness, damagePercentage, loyaltyRate = GetPetHappiness()
					local happyText = ""
					local damNumber = ""
					local loyaltyNumber = ""
					local loyaltyText = ""
					if happiness == 1 then
						happyText = crayon:Red(L["UNHAPPY"])
						damNumber = crayon:Red(damagePercentage.."%")
						loyaltyNumber = crayon:Red(loyaltyRate)
					  elseif happiness == 2 then
						happyText = crayon:Orange(L["CONTENT"])
						damNumber = crayon:Orange(damagePercentage.."%")
						loyaltyNumber = crayon:Orange("+ "..loyaltyRate)
					  elseif happiness == 3 then
						happyText = crayon:Green(L["HAPPY"])
						damNumber = crayon:Green(damagePercentage.."%")
						loyaltyNumber = crayon:Green("+ "..loyaltyRate)
					end
					if GetPetLoyalty() == L["LOYALTY_LEVEL1"] then
						loyaltyText = L["REBEL"]
					  elseif GetPetLoyalty() == L["LOYALTY_LEVEL2"] then
						loyaltyText = L["UNRULY"]
					  elseif GetPetLoyalty() == L["LOYALTY_LEVEL3"] then
						loyaltyText = L["SUBMIS"]
					  elseif GetPetLoyalty() == L["LOYALTY_LEVEL4"] then
						loyaltyText = L["DEPEND"]
					  elseif GetPetLoyalty() == L["LOYALTY_LEVEL5"] then
						loyaltyText = L["FAITHFUL"]
					  elseif GetPetLoyalty() == L["LOYALTY_LEVEL6"] then
						loyaltyText = L["BFRIEND"]
					end
					--Pet Happiness Level
					tooltipLine:AddLine(
						'text', "    "..L["HAPPINESS"],
						'text2', C1..happyText.." "
					)
					--Damage Bonus from Happiness
					tooltipLine:AddLine(
						'text', "    "..L["DAMAGEPERCT"],
						'text2', C1..damNumber.." "
					)
					--Pet Loyalty Gain/Loss Rate
					tooltipLine:AddLine(
						'text', "    "..L["LOYALTYRATE"],
						'text2', C1..loyaltyNumber.." "
					)
					--Pet Loyalty Level
					tooltipLine:AddLine(
						'text', "    "..L["LOYALTY"],
						'text2', C1..loyaltyText.." "
					)
					--Pet Food Types
					tooltipLine:AddLine(
						'text', "    "..L["FOOD"],
						'text2', C1..BuildListString(GetPetFoodTypes()).." "
					)
				end
			end
		end
		--PET ATTRIBUTES (ALL)
		if self.db.char.showAttributes then   
			local tooltipLine = tablet:AddCategory('id', L["TT_ATT"], 'columns', 2,
													'text', L["TT_ATT"],
													'func', 'ToggleCategory', 'arg1', self, 'arg2', L["TT_ATT"],
													'child_textR', 1, 'child_textG', 0.8, 'child_textB', 0,
													'showWithoutChildren', true,
													'checked', true, 'hasCheck', true, 'checkIcon',
													self.db.char.hidden[L["TT_ATT"]] and 
													'Interface\\Buttons\\UI-PlusButton-Up' or 'Interface\\Buttons\\UI-MinusButton-Up'
			)
			if not self.db.char.hidden[L["TT_ATT"]] then
				--STR, AGI, STA, INT, SPI
				local bStr, tStr, pStr, nStr = UnitStat("pet",1)
				local bAgi, tAgi, pAgi, nAgi = UnitStat("pet",2)
				local bSta, tSta, pSta, nSta = UnitStat("pet",3)
				local bInt, tInt, pInt, nInt = UnitStat("pet",4)
				local bSpi, tSpi, pSpi, nSpi = UnitStat("pet",5)
				if pStr == 0 and nStr == 0 then bStr = tStr
				  elseif nStr < 0 then bStr = crayon:Red(tStr)
				  else bStr = crayon:Green(tStr)
				end
				if pAgi == 0 and nAgi == 0 then bAgi = tAgi
				  elseif nAgi < 0 then bAgi = crayon:Red(tAgi)
				  else bAgi = crayon:Green(tAgi)
				end
				if pSta == 0 and nSta == 0 then bSta = tSta
				  elseif nSta < 0 then bSta = crayon:Red(tSta)
				  else bSta = crayon:Green(tSta)
				end
				if pInt == 0 and nInt == 0 then bInt = tInt
				  elseif nInt < 0 then bInt = crayon:Red(tInt)
				  else bInt = crayon:Green(tInt)
				end
				if pSpi == 0 and nSpi == 0 then bSpi = tSpi
				  elseif nSpi < 0 then bSpi = crayon:Red(tSpi)
				  else bSpi = crayon:Green(tSpi)
				end
				--ARCANE, FIRE, NATURE, FROST, SHADOW
				local bArc, tArc, pArc, nArc = UnitResistance("pet", 6)
				local bFir, tFir, pFir, nFir = UnitResistance("pet", 2)
				local bNat, tNat, pNat, nNat = UnitResistance("pet", 3)
				local bFst, tFst, pFst, nFst = UnitResistance("pet", 4)
				local bShw, tShw, pShw, nShw = UnitResistance("pet", 5)
				if pArc == 0 and nArc == 0 then bArc = tArc
				  elseif nArc < 0 then bArc = crayon:Red(tArc)
				  else bArc = crayon:Green(tArc)
				end
				if pFir == 0 and nFir == 0 then bFir = tFir
				  elseif nFir < 0 then bFir = crayon:Red(tFir)
				  else bFir = crayon:Green(tFir)
				end
				if pNat == 0 and nNat == 0 then bNat = tNat
				  elseif nNat < 0 then bNat = crayon:Red(tNat)
				  else bNat = crayon:Green(tNat)
				end
				if pFst == 0 and nFst == 0 then bFst = tFst
				  elseif nFst < 0 then bFst = crayon:Red(tFst)
				  else bFst = crayon:Green(tFst)
				end
				if pShw == 0 and nShw == 0 then bShw = tShw
				  elseif nShw < 0 then bShw = crayon:Red(tShw)
				  else bShw = crayon:Green(tShw)
				end
				tooltipLine:AddLine(
					'text', "    "..L["STR"]..C1..bStr,
					'text2', L["ARCANE"]..C1..bArc.." ",
					'text2R', 1, 'text2G', 0.8, 'text2B', 0
				)
				tooltipLine:AddLine(
					'text', "    "..L["AGI"]..C1..bAgi,
					'text2', L["FIRE"]..C1..bFir.." ",
					'text2R', 1, 'text2G', 0.8, 'text2B', 0
				)
				tooltipLine:AddLine(
					'text', "    "..L["STA"]..C1..bSta,
					'text2', L["NATURE"]..C1..bNat.." ",
					'text2R', 1, 'text2G', 0.8, 'text2B', 0
				)
				tooltipLine:AddLine(
					'text', "    "..L["INT"]..C1..bInt,
					'text2', L["FROST"]..C1..bFst.." ",
					'text2R', 1, 'text2G', 0.8, 'text2B', 0
				)
				tooltipLine:AddLine(
					'text', "    "..L["SPI"]..C1..bSpi,
					'text2', L["SHADOW"]..C1..bShw.." ",
					'text2R', 1, 'text2G', 0.8, 'text2B', 0
				)
			end
		end
		--PET COMBAT INFO (ALL)
		if self.db.char.showCombat then
			local tooltipLine = tablet:AddCategory('id', L["TT_COMBAT"], 'columns', 2,
													'text', L["TT_COMBAT"],
													'func', 'ToggleCategory', 'arg1', self, 'arg2', L["TT_COMBAT"],
													'child_textR', 1, 'child_textG', 0.8, 'child_textB', 0,
													'showWithoutChildren', true,
													'checked', true, 'hasCheck', true, 'checkIcon',
													self.db.char.hidden[L["TT_COMBAT"]] and 
													'Interface\\Buttons\\UI-PlusButton-Up' or 'Interface\\Buttons\\UI-MinusButton-Up'
			)
			if not self.db.char.hidden[L["TT_COMBAT"]] then
				--Armor
				local bArmor, eArmor, tArmor, pArmorBuff, nArmorBuff = UnitArmor("pet")
				if pArmorBuff - nArmorBuff < 0 then
					eArmor = crayon:Red(eArmor)
				elseif bArmor < eArmor then 
					eArmor = crayon:Green(eArmor)
				end
				--Attack Power
				local bAPwr, pAPBuff, nAPBuff = UnitAttackPower("pet")
				if pAPBuff - nAPBuff < 0 then
					bAPwr = crayon:Red(format(bAPwr + pAPBuff + nAPBuff))
				elseif pAPBuff - nAPBuff > 0 then
					bAPwr = crayon:Green(format(bAPwr + pAPBuff + nAPBuff))
				end
				--Defense
				local bDefense, pBuffDefense = UnitDefense("pet")
				local zDefense = bDefense + pBuffDefense
				if pBuffDefense > 0 then zDefense = crayon:Green(format(zDefense)) end
				--Damage Output Range
				local mLowDmg, mHiDmg, oLowDmg, oHiDmg, pDmgBuff, nDmgBuff, percentMod = UnitDamage("pet")
				local tmLowDmg = floor(mLowDmg)
				local tmHiDmg = floor(mHiDmg)
				local zDmgRng = format("%.f-%.f", tmLowDmg, tmHiDmg)
				if pDmgBuff - nDmgBuff < 0 then
					zDmgRng = crayon:Red(format("%.f-%.f", (tmLowDmg + pDmgBuff + nDmgBuff), (tmHiDmg + pDmgBuff + nDmgBuff)))
				elseif pDmgBuff - nDmgBuff > 0 then
					zDmgRng = crayon:Green(format("%.f-%.f", (tmLowDmg + pDmgBuff + nDmgBuff), (tmHiDmg + pDmgBuff + nDmgBuff)))
				end
				--Damage Reduction
				local aDmgRed = format("%.2f%%", ((tArmor / (tArmor + ((85 * petLVL) + 400))) * 100))
				if petLVL == 70 then
					aDmgRed = format("%.2f%%", ((tArmor / (tArmor + 10557.5)) * 100))
				elseif petLVL > 59 then
					aDmgRed = format("%.2f%%", ((tArmor / (tArmor - 22167.5 + 467.5 * petLVL)) * 100))
				end
				if aDmgRed > "75.00%" then aDmgRed = "75.00%" end
				--DPS
				local zDPS = format("%.1f", ((((mLowDmg + mHiDmg) * .5 + pDmgBuff + nDmgBuff) * percentMod) / UnitAttackSpeed("pet")))
				
				--Health, Atk Rating
				tooltipLine:AddLine(
					'text', "    "..L["HEALTH"]..C1..UnitHealthMax("pet"),
					'text2', L["ATK_RATING"] ..C1..UnitAttackBothHands("pet").." ",
					'text2R', 1, 'text2G', 0.8, 'text2B', 0
				)
				--Armor Class, Atk Power
				tooltipLine:AddLine(
					'text', "    "..L["ARMOR"]..C1..eArmor, 
					'text2', L["ATK_POWER"] ..C1..bAPwr.." ",
					'text2R', 1, 'text2G', 0.8, 'text2B', 0
				)
				--Defense Rating, Damage Output Range
				tooltipLine:AddLine(
					'text', "    "..L["DEFENSE"]..C1..zDefense,
					'text2', L["DMG_RANGE"]..C1..zDmgRng.." ",
					'text2R', 1, 'text2G', 0.8, 'text2B', 0
				)
				--Damage Mitigation, Damage Per Second
				tooltipLine:AddLine(
					'text', "    "..L["DAM_RED"]..C1..aDmgRed, 
					'text2', L["DPS"]..C1..zDPS.." ",
					'text2R', 1, 'text2G', 0.8, 'text2B', 0
				)
			end
		end
		--PET SKILLS (ALL)
		if self.db.char.showSkills then
			local tooltipLine = tablet:AddCategory('id', L["TT_SKILLS"], 'columns', 2,
													'text', L["TT_SKILLS"],
													'func', 'ToggleCategory', 'arg1', self, 'arg2', L["TT_SKILLS"],
													'child_textR', 1, 'child_textG', 0.8, 'child_textB', 0,
													'showWithoutChildren', true,
													'checked', true, 'hasCheck', true, 'checkIcon',
													self.db.char.hidden[L["TT_SKILLS"]] and 
													'Interface\\Buttons\\UI-PlusButton-Up' or 'Interface\\Buttons\\UI-MinusButton-Up'
			)
			if not self.db.char.hidden[L["TT_SKILLS"]] then 
				if self:IsHunter() then
					local totalTP, usedTP = GetPetTrainingPoints()
					--# of Training Points Available to Spend
					tooltipLine:AddLine(
						'text', "    "..L["TPOINTS"], 
						'text2', C1..(totalTP - usedTP).." "
					)
					tooltipLine:AddLine() tooltipLine:AddLine() --tooltipLine:AddLine()
				end
				if self:IsWarlock() then
					-- demonic knowledge
					-- skip section if not talented in demonic knowledge
					if demonicKnowledgeRank > 0 then
						if UnitExists("pet") then
							local demonSta, demonInt
							_, demonSta = UnitStat("pet", 3) -- stamina
							_, demonInt = UnitStat("pet", 4) -- intelligence
							tooltipLine:AddLine(
								'text', "    "..L["BONUSDAMAGE"].." ("..demonicKnowledgeRank..")",
								'text2', floor((demonSta + demonInt) * 0.05 * demonicKnowledgeRank).." "
							)
						else
							tooltipLine:AddLine(
								'text', "    "..L["NODEMON"]
							)
						end
					else
						tooltipLine:AddLine(
							'text', "    "..L["NOTALENT"]
						)
					end
					tooltipLine:AddLine() tooltipLine:AddLine() --tooltipLine:AddLine()
				end
				local i = 1
				while true do
				   local spellName, spellRank = GetSpellName(i, BOOKTYPE_PET)
				   if not spellName then
					  do break end
				   end
				   tooltipLine:AddLine(
						'text', "    "..spellName,
						'text2', C1..spellRank.." "
					)
				   i = i + 1
				end
			end
		end
		--HUNTER STABLED PETS
		if self:IsHunter() and self.db.char.showHerdInfo then  
			self:AddHerdInfo()
		end   
	else
		local toolTip = tablet:AddCategory(
			'columns', 1,
			'child_textR', 1,
			'child_textG', 0,
			'child_textB', 0
		)
		--Display when no pet is active
		toolTip:AddLine(
			'text', "    "..L["NOPET_TOOLTIP"]
		)
		--HUNTER STABLED PETS
		if self:IsHunter() and self.db.char.showHerdInfo then  
			self:AddHerdInfo()
		end   
	end
end


--------------------HEADER UPDATE--------------------	
function CritterInFu:UpdateText()
	if  self:IsTextShown() then
		if self.db.char.showPetName or self.db.char.showPetXP or self.db.char.showPetLevel then
			if HasPetUI() then
				local petName = UnitName("pet")
				local petLevel = UnitLevel("pet")
				local petType = UnitCreatureFamily("pet")
				local petIcon = GetPetIcon()
				local happiness = GetPetHappiness()
				local currXP, nextXP = GetPetExperience()
				local label = ''
				if petName ~= nil and petLevel ~= nil then
					if petName == UNKNOWNOBJECT then
						petName = L["NOPET"]
					end
					if petIcon ~= nil then
						self:SetIcon(petIcon)
					end
					if self:IsHunter() then
						if self.db.char.showPetName then
							if self.db.char.showPetLevel then
								if self.db.char.showPetXP then
									label = petName.." - "..L["HPLEVEL"]..petLevel..format(" (%.1f%%)", (currXP / nextXP * 100))
								else
									label = petName.." - "..L["HPLEVEL"]..petLevel
								end
							elseif self.db.char.showPetXP then
								label = petName..format(" (%.1f%%)", (currXP / nextXP * 100))
							else
								label = petName
							end
						elseif self.db.char.showPetLevel then
							if self.db.char.showPetXP then
								label = L["HPLEVEL"]..petLevel..format(" (%.1f%%)", (currXP / nextXP * 100))
							else
								label = L["HPLEVEL"]..petLevel
							end
						elseif self.db.char.showPetXP then
							label = format(" (%.1f%%)", (currXP / nextXP * 100))
						end
					elseif self.db.char.showPetName then
						label = petName.." - "..petType
					end
					if happiness == nil then				-- non hunter pet
						self:SetText(label)
					elseif happiness == 1 then
						self:SetText(crayon:Red(label))		-- unhappy
					elseif happiness == 2 then
						self:SetText(crayon:Orange(label))	-- content
					elseif happiness == 3 then
						self:SetText(crayon:Green(label))	-- happy
					end
				else
					-- pet name and level are nil which means there shouldn't have been a pet ui in the first place
					self:SetText(L["NOPET"])
					self:SetIcon("Interface\\AddOns\\FuBar_CritterInFu\\icons\\stable.tga")
				end
			else
				-- no pet ui found
				self:SetText(L["NOPET"])
				self:SetIcon("Interface\\AddOns\\FuBar_CritterInFu\\icons\\stable.tga")
			end
		else
			if UnitName("pet") ~= nil then
				local petIcon = GetPetIcon()
				if petIcon ~= nil then
					self:SetIcon(petIcon)
				end
				self:SetText(L["NOPET"])
			else
				self:SetText(L["NOPET"])
				self:SetIcon("Interface\\AddOns\\FuBar_CritterInFu\\icons\\stable.tga")
			end
		end
	end
end	

--------------------LEFT CLICKY FUNCTIONS--------------------	
function CritterInFu:OnClick()
	if self:IsHunter() then
		CastSpellByName(BS["Beast Training"])
	elseif self:IsWarlock() then
		ToggleSpellBook("pet")
	end
end
